﻿<%@ import Namespace="Soneta.Core" %>
<%@ import Namespace="Soneta.Types" %>
<%@ import Namespace="Soneta.Tools" %>
<%@ import Namespace="Soneta.Business" %>
<%@ import Namespace="Soneta.Kadry" %>
<%@ import Namespace="Soneta.OdziezRobocza" %>
<%@ import Namespace="System.Collections.Generic" %>
<%@ Register TagPrefix="cc2" Namespace="Soneta.OdziezRobocza" Assembly="Soneta.OdziezRobocza" %>
<%@ Register TagPrefix="cc1" Namespace="Soneta.Core.Web" Assembly="Soneta.Core.Web" %>
<%@ Register TagPrefix="ea" Namespace="Soneta.Web" Assembly="Soneta.Web" %>
<%@ Page Language="c#" CodePage="1200" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<HTML>
	<HEAD>
		<title>Przydział odzieży roboczej i wyposażenia</title>
		<script runat="server">
	
    private const int maxCols = 12;	    
		    	             
    Dictionary<string, int> dctColumn = new Dictionary<string, int>();
    Dictionary<string, Dictionary<string, int>> dctStan = new Dictionary<string, Dictionary<string, int>>();
		            
    void OnContextLoad(Object sender, EventArgs args) {
        Session session = dc.Session.Login.CreateSession(false, false);
        OdziezRoboczaModule odziezModule = OdziezRoboczaModule.GetInstance(session);

        dctStan.Add("***", null);
        
        foreach (ZestawStanow zs in odziezModule.ZestawyStanow) {
            if (zs.Blokada)
                continue;
            
            string stanowisko = zs.Stanowisko;
            foreach (PozycjaZestawu pz in odziezModule.PozycjeZestawu.WgZestaw[zs.Zestaw]) {
                if (pz.Blokada)
                    continue;

                Dictionary<string, int> dctWypos;
                int ilosc;

                if (!dctStan.TryGetValue(stanowisko, out dctWypos)) {
                    dctWypos = new Dictionary<string, int>();
                    dctWypos.Add(pz.Pozycja.Nazwa, pz.Ilosc);                        
                    dctStan.Add(stanowisko, dctWypos);
                }
                else {
                    if (!dctWypos.TryGetValue(pz.Pozycja.Nazwa, out ilosc))
                        dctWypos.Add(pz.Pozycja.Nazwa, pz.Ilosc);
                    else
                        dctWypos[pz.Pozycja.Nazwa] = ilosc + pz.Ilosc;
                    dctStan[stanowisko] = dctWypos;
                }

                if (!dctColumn.TryGetValue(pz.Pozycja.Nazwa, out ilosc))
                    dctColumn.Add(pz.Pozycja.Nazwa, pz.Pozycja.OkresUz);
            }
        }

        GridColumn gch = new GridColumn();
        gch.Align = HorizontalAlign.Left;
        gch.VAlign = VerticalAlign.Top;
        gch.Caption = "Stanowisko / Wyposażenie";
        Grid1.Columns.Add(gch);
        Grid2.Columns.Add(gch);
        Grid3.Columns.Add(gch);
        Grid4.Columns.Add(gch);
        Grid5.Columns.Add(gch);
        Grid6.Columns.Add(gch);
        Grid7.Columns.Add(gch);
        Grid8.Columns.Add(gch);
        Grid9.Columns.Add(gch);
        Grid10.Columns.Add(gch);
        Grid1.Visible = false;
        Grid2.Visible = false;
        Grid3.Visible = false;
        Grid4.Visible = false;
        Grid5.Visible = false;
        Grid6.Visible = false;
        Grid7.Visible = false;
        Grid8.Visible = false;
        Grid9.Visible = false;
        Grid10.Visible = false;

        int col = 0, grd = 0;
        foreach (string nazwa in dctColumn.Keys) {
            GridColumn gcr = new GridColumn();
            gcr.Align = HorizontalAlign.Right;
            gcr.VAlign = VerticalAlign.Top;
            gcr.ID = nazwa;
            gcr.Caption = nazwa;
            switch (grd) {
                case 0:
                    Grid1.Columns.Add(gcr);
                    Grid1.Visible = true;
                    break;
                case 1:
                    Grid2.Columns.Add(gcr);
                    Grid2.Visible = true;
                    break;
                case 2:
                    Grid3.Columns.Add(gcr);
                    Grid3.Visible = true;
                    break;
                case 3:
                    Grid4.Columns.Add(gcr);
                    Grid4.Visible = true;
                    break;
                case 4:
                    Grid5.Columns.Add(gcr);
                    Grid5.Visible = true;
                    break;
                case 5:
                    Grid6.Columns.Add(gcr);
                    Grid6.Visible = true;
                    break;
                case 6:
                    Grid7.Columns.Add(gcr);
                    Grid7.Visible = true;
                    break;
                case 7:
                    Grid8.Columns.Add(gcr);
                    Grid8.Visible = true;
                    break;
                case 8:
                    Grid9.Columns.Add(gcr);
                    Grid9.Visible = true;
                    break;
                case 9:
                    Grid10.Columns.Add(gcr);
                    Grid10.Visible = true;
                    break;
            }
            col++;
            if (col == maxCols) {
                col = 0; grd++;
            }            
        }

        Grid1.DataSource = dctStan.Keys;
        Grid2.DataSource = dctStan.Keys;
        Grid3.DataSource = dctStan.Keys;
        Grid4.DataSource = dctStan.Keys;
        Grid5.DataSource = dctStan.Keys;
        Grid6.DataSource = dctStan.Keys;
        Grid7.DataSource = dctStan.Keys;
        Grid8.DataSource = dctStan.Keys;
        Grid9.DataSource = dctStan.Keys;
        Grid10.DataSource = dctStan.Keys;
    }

    void Grid_BeforeRow(Object sender, RowEventArgs args) {
        string stanowisko = (string)args.Row;
        Grid grid = (Grid)sender;

        if (stanowisko == "***") {
            grid.Columns[0].AddLine("Okres używalności w miesiącach");
            grid.Columns[0].AddLine("&nbsp;");
                        
            foreach (string nazwa in dctColumn.Keys)
                for (int col = 0; col < grid.Columns.Count; col++)
                    if (grid.Columns[col].ID == nazwa) {
                        grid.Columns[col].EditValue = dctColumn[nazwa].ToString();
                        break;
                    }
           
            return;
        }

        Dictionary<string, int> dctWypos = dctStan[stanowisko];
        if (dctWypos == null)
            return;

        grid.Columns[0].EditValue = stanowisko;
        foreach (string nazwa in dctWypos.Keys)
            for (int col = 0; col < grid.Columns.Count; col++)
                if (grid.Columns[col].ID == nazwa) {
                    grid.Columns[col].EditValue = dctWypos[nazwa];
                    break;
                }
    }        
    
    static void Msg(object v) {
    }

	</script>

	<meta content="False" name="vs_showGrid">
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<meta content="Microsoft Visual Studio 7.0" name="GENERATOR">
	<meta content="C#" name="CODE_LANGUAGE">
	<meta content="JavaScript" name="vs_defaultClientScript">
	<meta content="http://schemas.microsoft.com/intellisense/ie5" name="vs_targetSchema">
	</HEAD>
	<body>
		<form id="PrzydzialOdziezy" method="post" runat="server">
			<ea:datacontext id="dc" runat="server" oncontextload="OnContextLoad" Landscape="true">
            </ea:datacontext>
            <cc1:ReportHeader NagłówekOddziału="NagłówekOddziału" id="ReportHeader1" 
                title="Przydział odzieży roboczej i wyposażenia dla stanowisk" runat="server">
            </cc1:ReportHeader>
            <ea:Grid id="Grid1" runat="server" OnBeforeRow="Grid_BeforeRow"></ea:Grid><br/>
            <ea:Grid id="Grid2" runat="server" OnBeforeRow="Grid_BeforeRow"></ea:Grid><br/>
            <ea:Grid id="Grid3" runat="server" OnBeforeRow="Grid_BeforeRow"></ea:Grid><br/>
            <ea:Grid id="Grid4" runat="server" OnBeforeRow="Grid_BeforeRow"></ea:Grid><br/>
            <ea:Grid id="Grid5" runat="server" OnBeforeRow="Grid_BeforeRow"></ea:Grid><br/>
            <ea:Grid id="Grid6" runat="server" OnBeforeRow="Grid_BeforeRow"></ea:Grid><br/>
            <ea:Grid id="Grid7" runat="server" OnBeforeRow="Grid_BeforeRow"></ea:Grid><br/>
            <ea:Grid id="Grid8" runat="server" OnBeforeRow="Grid_BeforeRow"></ea:Grid><br/>
            <ea:Grid id="Grid9" runat="server" OnBeforeRow="Grid_BeforeRow"></ea:Grid><br/>
            <ea:Grid id="Grid10" runat="server" OnBeforeRow="Grid_BeforeRow"></ea:Grid><br/>
            <cc1:ReportFooter id="ReportFooter1" runat="server" TheEnd="False">
            </cc1:ReportFooter>
        </form>
	</body>
</HTML>
